#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
    Un hola_mundo con Glade y PyGTK
    Versión 1: Añadimos gestión de eventos y señales
    Profesores de Paradigmas de Programación
    Curso 2010/11

"""

import gtk

class holamundo():
    """ 
        Clase responsable de la interfaz
    """
    def __init__(self):
        """ Inicialización """
        # Cargamos la interfaz generada con glade
        self.glade=gtk.Builder()
        self.glade.add_from_file('hola.glade')
        # Podemos extraer algunos de los objetos que forman la interfaz
        # Utilizamos para ello el nombre que identifica al widget en glade
        self.ventana=self.glade.get_object('window1')
        # Conectamos todos los eventos descritos en la interfaz con sus
        # correspondientes manejadores. Cuando se active la señal (al pulsar
        # el botón, por ejemplo, se llamará al correspondiente método de
        # esta clase.
        self.glade.connect_signals(self)
        # Si no hemos hecho visible la ventana desde glade, podemos hacerlo
        # desde el código
        self.ventana.show()

    def on_button1_clicked(self,widget):
        """ Gestión de la pulsación de un botón """
        # Para las señales nos envían sólo el widget
        print "Pulsación en el botón"

    def on_window1_delete_event(self,widget,event):
        """ Gestión del borrado de la ventana principal """
        # Para los eventos además del widget nos envían el evento
        # Este evento contiene información extra sobre lo que ha ocurrido en
        # la ventana (tecla pulsada, botón pulsado,...)
        print "Señal para cerrar la ventana"
        gtk.main_quit()
        # Si no devolvemos nada, el evento no se considera procesado, se
        # retransmite y acaba siendo una destrucción de la ventana. Si
        # quisieramos evitar la destrucción de la ventana (mediante una
        # ventana para pedir información, por ejemplo) habría que devolver
        # True
        print "Fuera del bucle de control de eventos"
        
# Para lanzar la aplicación...
if __name__=='__main__':
    # Instanciamos la interfaz
    app=holamundo()
    # Lanzamos el bucle de gestión de eventos
    gtk.main()
    print "Termina el programa"
